#!/usr/bin/env python
#-------------------------------------------------------------------------------

import cgi
import cgitb; cgitb.enable()  # for troubleshooting
import json
from subprocess import call
import time


#-------------------------------------------------------------------------------

cfgPath = 'camera-cfg.json'
argPath = 'camera-cfg.arg'

#-------------------------------------------------------------------------------

def MkSizeArg(id, val):
  w, h = val.split('x')
  return '--width ' + w + ' --height ' + h

def MkKBpsArg(id, val):
  return '--' + id + ' ' + str((int(val) * 1000 * 8))

def MkEnumArg(id, val):
  return '--' + id + ' ' + val

def MkBoolArg(id, val):
  if val == 'off':
    return ''
  else:
    return '--' + id

#-------------------------------------------------------------------------------

MkTypeArg = \
{
  'kbps' : MkKBpsArg,
  'enum' : MkEnumArg,
  'bool' : MkBoolArg,
  'size' : MkSizeArg,
}

# read json configuration file
cfgFile = open(cfgPath)
cfg = json.load(cfgFile)
cfgFile.close()

form = cgi.FieldStorage()

cmdArgs = ''
for item in cfg['raspivid']:
  if item['id'] in form.keys():
    value = form[item['id']].value
    if value in item['opt']:
      item['act'] = value
  cmdArgs += ' ' + MkTypeArg[item['type']](item['id'], item['act'])
cmdArgs = cmdArgs.strip()

# update json configuration file
cfgFile = open(cfgPath, 'w+')
cfgFile.write(json.dumps(cfg, sort_keys=True, indent=2, separators=(',', ': ')))
cfgFile.close()

# update raspivid configuration file
argFile = open(argPath, 'w+')
argFile.write("RASPIVID_WEB_CFG=\"" + cmdArgs + "\"")
argFile.close()

# restart services
call(["sudo", "/etc/init.d/videostream", "restart"])

# give them some time to start
time.sleep(2)

# print just for debugging
print "Content-type: text/html"
print
print cmdArgs
